// Program to time the binary search algorithm

#include <iostream>
#include <ctime>
using namespace std;

// Prototypes
int binarySearch(int array[], int size, int value);

const int ARRAY_SIZE = 100000;

int main() {
	int evenList[ARRAY_SIZE];
	int evenNumber, oddNumber, index, location;
	unsigned startTime, endTime;

	// fill evenList with even values 0, 2, 4, ..., 199996, 199998
	evenNumber = 0;
	for (index = 0; index < ARRAY_SIZE; index++) {
		evenList[index] = evenNumber;
		evenNumber += 2;
	} // end for

	// Time successful searches for target values 0, 2, 4, ..., 199998
	startTime = static_cast<unsigned>(time(0));
	for (evenNumber = 0; evenNumber <= ARRAY_SIZE*2-2; evenNumber += 2) {
		location = binarySearch(evenList, ARRAY_SIZE, evenNumber);
	} // end for
	endTime = static_cast<unsigned>(time(0));
	cout << "Binary search of " << ARRAY_SIZE << " successful searches "
		<< "took " << endTime - startTime << " seconds." << endl;	
	
	// Time unsuccessful searches for target values 1, 3, 5, ..., 199999
	startTime = static_cast<unsigned>(time(0));
	for (oddNumber = 1; oddNumber <= ARRAY_SIZE*2-1; oddNumber += 2) {
		location = binarySearch(evenList, ARRAY_SIZE, oddNumber);
	} // end for
	endTime = static_cast<unsigned>(time(0));
	cout << "Binary search of " << ARRAY_SIZE << " unsuccessful searches "
		<< "took " << endTime - startTime << " seconds." << endl;	

} // end main


//***************************************************************
// The binarySearch function performs a binary search on an     *
// integer array. array, which has a maximum of size elements,  *
// is searched for the number stored in value. If the number is *
// found, its array subscript is returned. Otherwise, -1 is     *
// returned indicating the value was not in the array.          *
//***************************************************************

int binarySearch(int array[], int size, int value)
{
   int first = 0,             // First array element
       last = size - 1,       // Last array element
       middle,                // Mid point of search
       position = -1;         // Position of search value
   bool found = false;        // Flag

   while (!found && first <= last)
   {
      middle = (first + last) / 2;     // Calculate mid point
      if (array[middle] == value)      // If value is found at mid
      {
         found = true;
         position = middle;
      }
      else if (array[middle] > value)  // If value is in lower half
         last = middle - 1;
      else
         first = middle + 1;           // If value is in upper half
   }
   return position;
}
