// Program to time the simple sort algorithms:  selection and bubble sort

#include <iostream>
#include <cstdlib>
#include <ctime>
using namespace std;

// Prototypes
int randomInteger(int rangeStart, int rangeEnd);
void bubbleSortTextbook(int array[], int size);
void bubbleSort(int array[], int size);
void selectionSort(int [], int);

const int ARRAY_SIZE = 50000;

int main() {
	int randomList[ARRAY_SIZE];
	int index;
	unsigned startTime, endTime, seedValue;

	// fill randomList with randomly generated integers
	seedValue = 10;
	srand(seedValue);

	for (index = 0; index < ARRAY_SIZE; index++) {
		randomList[index] = randomInteger(1,ARRAY_SIZE*2);
	} // end for

	// Time bubbleSortTextbook sort
	startTime = static_cast<unsigned>(time(0));
	bubbleSortTextbook(randomList, ARRAY_SIZE);
	endTime = static_cast<unsigned>(time(0));
	cout << "bubbleSortTextbook sort of " << ARRAY_SIZE << " random integers "
		<< "took " << endTime - startTime << " seconds." << endl;	
	
	// Time bubbleSortTextbook sort
	startTime = static_cast<unsigned>(time(0));
	bubbleSortTextbook(randomList, ARRAY_SIZE);
	endTime = static_cast<unsigned>(time(0));
	cout << "bubbleSortTextbook sort of " << ARRAY_SIZE << " SORTED integers "
		<< "took " << endTime - startTime << " seconds." << endl;	
	
	// fill randomList with randomly generated integers
	seedValue = 10;
	srand(seedValue);

	for (index = 0; index < ARRAY_SIZE; index++) {
		randomList[index] = randomInteger(1,ARRAY_SIZE*2);
	} // end for

	// Time bubbleSort sort
	startTime = static_cast<unsigned>(time(0));
	bubbleSort(randomList, ARRAY_SIZE);
	endTime = static_cast<unsigned>(time(0));
	cout << "bubbleSort sort of " << ARRAY_SIZE << " random integers "
		<< "took " << endTime - startTime << " seconds." << endl;	
	
	// Time bubbleSort sort
	startTime = static_cast<unsigned>(time(0));
	bubbleSort(randomList, ARRAY_SIZE);
	endTime = static_cast<unsigned>(time(0));
	cout << "bubbleSort sort of " << ARRAY_SIZE << " SORTED integers "
		<< "took " << endTime - startTime << " seconds." << endl;	
	

	// fill randomList with randomly generated integers
	seedValue = 10;
	srand(seedValue);

	for (index = 0; index < ARRAY_SIZE; index++) {
		randomList[index] = randomInteger(1,ARRAY_SIZE*2);
	} // end for

	// Time selectionSort sort
	startTime = static_cast<unsigned>(time(0));
	selectionSort(randomList, ARRAY_SIZE);
	endTime = static_cast<unsigned>(time(0));
	cout << "selectionSort sort of " << ARRAY_SIZE << " random integers "
		<< "took " << endTime - startTime << " seconds." << endl;	
	
	// Time selectionSort sort
	startTime = static_cast<unsigned>(time(0));
	selectionSort(randomList, ARRAY_SIZE);
	endTime = static_cast<unsigned>(time(0));
	cout << "selectionSort sort of " << ARRAY_SIZE << " SORTED integers "
		<< "took " << endTime - startTime << " seconds." << endl;	
	

} // end main

//***********************************************************
// Definition of function bubbleSortTextbook                *
// This function performs an ascending order bubble sort on *
// array. size is the number of elements in the array.     *
//***********************************************************

void bubbleSortTextbook(int array[], int size) {
   bool swap;
   int temp;

   do {
      swap = false;
      for (int count = 0; count < (size - 1); count++) {

         if (array[count] > array[count + 1]) {

            temp = array[count];
            array[count] = array[count + 1];
            array[count + 1] = temp;
            swap = true;

         } // end if

      } // end for

   } while (swap);

} // end bubbleSortTextbook


//***********************************************************
// Definition of function bubbleSort                        *
// This function performs an ascending order bubble sort on *
// array. size is the number of elements in the array.     *
//***********************************************************

void bubbleSort(int array[], int size) {
	bool swap;
	int temp;
	int lastUnsorted;
	
	lastUnsorted = size-1;
	do 	{
		swap = false;
		for (int count = 0; count < lastUnsorted; count++) {
			if (array[count] > array[count + 1]) {
				temp = array[count];
				array[count] = array[count + 1];
				array[count + 1] = temp;
				swap = true;
			} // end if
		} // end for
		lastUnsorted--;
	} while (swap);
} // end bubbleSort


//***********************************************************
// Definition of function selectSort                        *
// This function performs an ascending order selection sort on *
// array. size is the number of elements in the array.     *
//***********************************************************
void selectionSort(int array[], int size)
{
   int startScan, minIndex, minValue;

   for (startScan = 0; startScan < (size - 1); startScan++)
   {
      minIndex = startScan;
      minValue = array[startScan];
      for(int index = startScan + 1; index < size; index++)
      {
         if (array[index] < minValue)
         {
            minValue = array[index];
            minIndex = index;
         }
      }
      array[minIndex] = array[startScan];
      array[startScan] = minValue;
   }
} // end selectionSort

//****************************************************
// Definition of function randomInteger
// This function returns a random integer between the 
// two parameters passed into it.
//****************************************************
int randomInteger(int rangeStart, int rangeEnd) {
	int temp;

	if (rangeStart > rangeEnd) {  
		temp = rangeStart;
		rangeStart = rangeEnd;
		rangeEnd = temp;
	} // end if

	temp = rand() % (rangeEnd - rangeStart + 1) + rangeStart;

	return temp;

} // end randomInteger 

